diff a/src/jdk.jfr/share/classes/jdk/jfr/internal/MirrorEvents.java b/src/jdk.jfr/share/classes/jdk/jfr/internal/MirrorEvents.java
--- a/src/jdk.jfr/share/classes/jdk/jfr/internal/MirrorEvents.java
+++ b/src/jdk.jfr/share/classes/jdk/jfr/internal/MirrorEvents.java
@@ -41,11 +41,10 @@
 import jdk.jfr.events.SocketReadEvent;
 import jdk.jfr.events.SocketWriteEvent;
 import jdk.jfr.events.TLSHandshakeEvent;
 import jdk.jfr.events.ThreadSleepEvent;
 import jdk.jfr.events.VirtualThreadEndEvent;
-import jdk.jfr.events.VirtualThreadPinnedEvent;
 import jdk.jfr.events.VirtualThreadStartEvent;
 import jdk.jfr.events.VirtualThreadSubmitFailedEvent;
 import jdk.jfr.events.X509CertificateEvent;
 import jdk.jfr.events.X509ValidationEvent;
 import jdk.jfr.internal.util.Utils;
@@ -70,11 +69,10 @@
         register("jdk.internal.event.SocketWriteEvent", SocketWriteEvent.class);
         register("jdk.internal.event.ThreadSleepEvent", ThreadSleepEvent.class);
         register("jdk.internal.event.TLSHandshakeEvent", TLSHandshakeEvent.class);
         register("jdk.internal.event.VirtualThreadStartEvent", VirtualThreadStartEvent.class);
         register("jdk.internal.event.VirtualThreadEndEvent", VirtualThreadEndEvent.class);
-        register("jdk.internal.event.VirtualThreadPinnedEvent", VirtualThreadPinnedEvent.class);
         register("jdk.internal.event.VirtualThreadSubmitFailedEvent", VirtualThreadSubmitFailedEvent.class);
         register("jdk.internal.event.X509CertificateEvent", X509CertificateEvent.class);
         register("jdk.internal.event.X509ValidationEvent", X509ValidationEvent.class);
         register("jdk.internal.event.ErrorThrownEvent", ErrorThrownEvent.class);
         register("jdk.internal.event.ExceptionStatisticsEvent", ExceptionStatisticsEvent.class);
diff a/src/jdk.jfr/share/conf/jfr/default.jfc b/src/jdk.jfr/share/conf/jfr/default.jfc
--- a/src/jdk.jfr/share/conf/jfr/default.jfc
+++ b/src/jdk.jfr/share/conf/jfr/default.jfc
@@ -73,11 +73,10 @@
     </event>
 
     <event name="jdk.VirtualThreadPinned">
       <setting name="enabled">true</setting>
       <setting name="stackTrace">true</setting>
-      <setting name="threshold">20 ms</setting>
     </event>
 
     <event name="jdk.VirtualThreadSubmitFailed">
       <setting name="enabled">true</setting>
       <setting name="stackTrace">true</setting>
diff a/src/jdk.jfr/share/conf/jfr/profile.jfc b/src/jdk.jfr/share/conf/jfr/profile.jfc
--- a/src/jdk.jfr/share/conf/jfr/profile.jfc
+++ b/src/jdk.jfr/share/conf/jfr/profile.jfc
@@ -73,11 +73,10 @@
     </event>
 
     <event name="jdk.VirtualThreadPinned">
       <setting name="enabled">true</setting>
       <setting name="stackTrace">true</setting>
-      <setting name="threshold">20 ms</setting>
     </event>
 
     <event name="jdk.VirtualThreadSubmitFailed">
       <setting name="enabled">true</setting>
       <setting name="stackTrace">true</setting>
diff a/src/jdk.management/share/classes/com/sun/management/internal/PlatformMBeanProviderImpl.java b/src/jdk.management/share/classes/com/sun/management/internal/PlatformMBeanProviderImpl.java
--- a/src/jdk.management/share/classes/com/sun/management/internal/PlatformMBeanProviderImpl.java
+++ b/src/jdk.management/share/classes/com/sun/management/internal/PlatformMBeanProviderImpl.java
@@ -163,43 +163,47 @@
                         threadMBean);
             }
         });
 
         /**
-         * VirtualThreadSchedulerMXBean.
+         * VirtualThreadSchedulerMXBean registered when using JDK's virtual thread scheduler.
          */
-        initMBeanList.add(new PlatformComponent<VirtualThreadSchedulerMXBean>() {
-            private final Set<Class<? extends VirtualThreadSchedulerMXBean>> mbeanInterfaces =
-                    Set.of(VirtualThreadSchedulerMXBean.class);
-            private final Set<String> mbeanInterfaceNames =
-                    Set.of(VirtualThreadSchedulerMXBean.class.getName());
-            private VirtualThreadSchedulerMXBean impl;
-
-            @Override
-            public Set<Class<? extends VirtualThreadSchedulerMXBean>> mbeanInterfaces() {
-                return mbeanInterfaces;
-            }
+        PrivilegedAction<String> pa = () -> System.getProperty("jdk.virtualThreadScheduler.implClass");
+        String value = AccessController.doPrivileged(pa);
+        if (value == null) {
+            initMBeanList.add(new PlatformComponent<VirtualThreadSchedulerMXBean>() {
+                private final Set<Class<? extends VirtualThreadSchedulerMXBean>> mbeanInterfaces =
+                        Set.of(VirtualThreadSchedulerMXBean.class);
+                private final Set<String> mbeanInterfaceNames =
+                        Set.of(VirtualThreadSchedulerMXBean.class.getName());
+                private VirtualThreadSchedulerMXBean impl;
+
+                @Override
+                public Set<Class<? extends VirtualThreadSchedulerMXBean>> mbeanInterfaces() {
+                    return mbeanInterfaces;
+                }
 
-            @Override
-            public Set<String> mbeanInterfaceNames() {
-                return mbeanInterfaceNames;
-            }
+                @Override
+                public Set<String> mbeanInterfaceNames() {
+                    return mbeanInterfaceNames;
+                }
 
-            @Override
-            public String getObjectNamePattern() {
-                return "jdk.management:type=VirtualThreadScheduler";
-            }
+                @Override
+                public String getObjectNamePattern() {
+                    return "jdk.management:type=VirtualThreadScheduler";
+                }
 
-            @Override
-            public Map<String, VirtualThreadSchedulerMXBean> nameToMBeanMap() {
-                VirtualThreadSchedulerMXBean impl = this.impl;
-                if (impl == null) {
-                    this.impl = impl = VirtualThreadSchedulerImpls.create();
+                @Override
+                public Map<String, VirtualThreadSchedulerMXBean> nameToMBeanMap() {
+                    VirtualThreadSchedulerMXBean impl = this.impl;
+                    if (impl == null) {
+                        this.impl = impl = VirtualThreadSchedulerImpls.create();
+                    }
+                    return Map.of("jdk.management:type=VirtualThreadScheduler", impl);
                 }
-                return Map.of("jdk.management:type=VirtualThreadScheduler", impl);
-            }
-        });
+            });
+        }
 
         /**
          * OperatingSystemMXBean
          */
         initMBeanList.add(new PlatformComponent<OperatingSystemMXBean>() {
diff a/test/hotspot/gtest/nmt/test_vmatree.cpp b/test/hotspot/gtest/nmt/test_vmatree.cpp
--- a/test/hotspot/gtest/nmt/test_vmatree.cpp
+++ b/test/hotspot/gtest/nmt/test_vmatree.cpp
@@ -29,11 +29,11 @@
 #include "nmt/vmatree.hpp"
 #include "runtime/os.hpp"
 #include "unittest.hpp"
 
 using Tree = VMATree;
-using Node = Tree::TreapNode;
+using TNode = Tree::TreapNode;
 using NCS = NativeCallStackStorage;
 
 class NMTVMATreeTest : public testing::Test {
 public:
   NCS ncs;
@@ -75,11 +75,11 @@
     return x->val().out.type();
   }
 
   int count_nodes(Tree& tree) {
     int count = 0;
-    treap(tree).visit_in_order([&](Node* x) {
+    treap(tree).visit_in_order([&](TNode* x) {
       ++count;
     });
     return count;
   }
 
@@ -128,11 +128,11 @@
     Tree tree;
     tree.reserve_mapping(0, 100 * 10, rd);
     for (int i = 0; i < 10; i++) {
       tree.commit_mapping(i * 100, 100, rd);
     }
-    treap(tree).visit_in_order([&](Node* x) {
+    treap(tree).visit_in_order([&](TNode* x) {
       VMATree::StateType in = in_type_of(x);
       VMATree::StateType out = out_type_of(x);
       EXPECT_TRUE((in == VMATree::StateType::Released && out == VMATree::StateType::Committed) ||
                   (in == VMATree::StateType::Committed && out == VMATree::StateType::Released));
     });
@@ -153,11 +153,11 @@
       }
       return false;
     };
 
     int i = 0;
-    treap(tree).visit_in_order([&](Node* x) {
+    treap(tree).visit_in_order([&](TNode* x) {
       if (i < 16) {
         found[i] = x->key();
       }
       i++;
     });
@@ -185,11 +185,11 @@
   VMATree::RegionData rd1(si[0], mtTest);
   VMATree::RegionData rd2(si[1], mtNone);
   tree.reserve_mapping(0, 100, rd1);
   tree.commit_mapping(20, 50, rd2, true);
   tree.uncommit_mapping(30, 10, rd2);
-  tree.visit_in_order([&](Node* node) {
+  tree.visit_in_order([&](TNode* node) {
     if (node->key() != 100) {
       EXPECT_EQ(mtTest, node->val().out.mem_tag()) << "failed at: " << node->key();
       if (node->key() != 20 && node->key() != 40) {
         EXPECT_EQ(VMATree::StateType::Reserved, node->val().out.type());
       }
@@ -225,11 +225,11 @@
     Tree tree;
     VMATree::RegionData rd{si[0], mtTest };
     VMATree::RegionData rd2{si[1], mtNMT };
     tree.commit_mapping(50, 50, rd2);
     tree.reserve_mapping(0, 100, rd);
-    treap(tree).visit_in_order([&](Node* x) {
+    treap(tree).visit_in_order([&](TNode* x) {
       EXPECT_TRUE(x->key() == 0 || x->key() == 100);
       if (x->key() == 0) {
         EXPECT_EQ(x->val().out.regiondata().mem_tag, mtTest);
       }
     });
@@ -262,11 +262,11 @@
     Tree::RegionData rd{si[0], mtNMT};
     VMATree::RegionData rd2{si[1], mtTest};
     Tree tree;
     tree.reserve_mapping(0, 100, rd);
     tree.commit_mapping(0, 100, rd2);
-    treap(tree).visit_range_in_order(0, 99999, [&](Node* x) {
+    treap(tree).visit_range_in_order(0, 99999, [&](TNode* x) {
       if (x->key() == 0) {
         EXPECT_EQ(mtTest, x->val().out.regiondata().mem_tag);
       }
       if (x->key() == 100) {
         EXPECT_EQ(mtTest, x->val().in.regiondata().mem_tag);
diff a/test/hotspot/jtreg/TEST.groups b/test/hotspot/jtreg/TEST.groups
--- a/test/hotspot/jtreg/TEST.groups
+++ b/test/hotspot/jtreg/TEST.groups
@@ -774,5 +774,10 @@
 # JDB tests
 vmTestbase_nsk_jdb = \
   vmTestbase/nsk/jdb
 
 # vmTestbase_*_quick groups are defined in TEST.quick-groups
+
+hotspot_remaining = \
+ :hotspot_all_no_apps \
+  -vmTestbase \
+  -:tier1
diff a/test/hotspot/jtreg/compiler/codecache/stress/OverloadCompileQueueTest.java b/test/hotspot/jtreg/compiler/codecache/stress/OverloadCompileQueueTest.java
--- a/test/hotspot/jtreg/compiler/codecache/stress/OverloadCompileQueueTest.java
+++ b/test/hotspot/jtreg/compiler/codecache/stress/OverloadCompileQueueTest.java
@@ -1,7 +1,7 @@
 /*
- * Copyright (c) 2014, 2023, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2014, 2024, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -37,10 +37,11 @@
  *                   -XX:CompileCommand=dontinline,compiler.codecache.stress.Helper$TestCase::method
  *                   -XX:CompileCommand=exclude,java.lang.Thread::sleep
  *                   -XX:CompileCommand=exclude,java.lang.Thread::sleepNanos
  *                   -XX:CompileCommand=exclude,java.lang.Thread::beforeSleep
  *                   -XX:CompileCommand=exclude,java.lang.Thread::afterSleep
+ *                   -XX:CompileCommand=exclude,java.util.concurrent.TimeUnit::toNanos
  *                   -XX:CompileCommand=exclude,java.lang.Math::min
  *                   -XX:CompileCommand=exclude,jdk.internal.event.ThreadSleepEvent::*
  *                   -XX:CompileCommand=exclude,jdk.internal.event.SleepEvent::*
  *                   -XX:CompileCommand=exclude,jdk.internal.event.Event::*
  *                   -XX:-SegmentedCodeCache
@@ -50,10 +51,11 @@
  *                   -XX:CompileCommand=dontinline,compiler.codecache.stress.Helper$TestCase::method
  *                   -XX:CompileCommand=exclude,java.lang.Thread::sleep
  *                   -XX:CompileCommand=exclude,java.lang.Thread::sleepNanos
  *                   -XX:CompileCommand=exclude,java.lang.Thread::beforeSleep
  *                   -XX:CompileCommand=exclude,java.lang.Thread::afterSleep
+ *                   -XX:CompileCommand=exclude,java.util.concurrent.TimeUnit::toNanos
  *                   -XX:CompileCommand=exclude,java.lang.Math::min
  *                   -XX:CompileCommand=exclude,jdk.internal.event.ThreadSleepEvent::*
  *                   -XX:CompileCommand=exclude,jdk.internal.event.SleepEvent::*
  *                   -XX:CompileCommand=exclude,jdk.internal.event.Event::*
  *                   -XX:+SegmentedCodeCache
diff a/test/hotspot/jtreg/runtime/vthread/JNIMonitor/JNIMonitor.java b/test/hotspot/jtreg/runtime/vthread/JNIMonitor/JNIMonitor.java
--- a/test/hotspot/jtreg/runtime/vthread/JNIMonitor/JNIMonitor.java
+++ b/test/hotspot/jtreg/runtime/vthread/JNIMonitor/JNIMonitor.java
@@ -117,10 +117,12 @@
             // Enable the JNI warning
             "-Xcheck:jni",
             "-Xlog:jni=debug",
             // Enable thread termination logging as a visual cross-check
             "-Xlog:thread+os=info",
+            // We only count monitors in LM_LEGACY mode
+            "-XX:LockingMode=1",
             "JNIMonitor$" + test,
         };
         OutputAnalyzer oa = ProcessTools.executeTestJava(cmdArgs);
         oa.shouldHaveExitValue(0);
         oa.stdoutShouldMatch(terminated);
@@ -217,16 +219,20 @@
                 throw new RuntimeException(e);
             }
         }
 
         static void runTest(int nThreads, boolean skipUnlock, boolean throwOnExit) throws Throwable {
-            final Object monitor = new Object();
+            final Object[] monitors = new Object[nThreads];
+            for (int i = 0; i < nThreads; i++) {
+                monitors[i] = new Object();
+            }
             final AtomicReference<Throwable> exception = new AtomicReference();
             // Ensure all our VT's operate of the same carrier, sequentially.
             ExecutorService scheduler = Executors.newSingleThreadExecutor();
             ThreadFactory factory = virtualThreadBuilder(scheduler).factory();
             for (int i = 0 ; i < nThreads; i++) {
+                Object monitor = skipUnlock ? monitors[i] : monitors[0];
                 Thread th = factory.newThread(() -> {
                         try {
                             int res = monitorEnter(monitor);
                             Asserts.assertTrue(res == 0, "monitorEnter should return 0.");
                             Asserts.assertTrue(Thread.holdsLock(monitor), "monitor should be owned");
diff a/test/hotspot/jtreg/serviceability/dcmd/thread/ThreadDumpToFileTest.java b/test/hotspot/jtreg/serviceability/dcmd/thread/ThreadDumpToFileTest.java
--- a/test/hotspot/jtreg/serviceability/dcmd/thread/ThreadDumpToFileTest.java
+++ b/test/hotspot/jtreg/serviceability/dcmd/thread/ThreadDumpToFileTest.java
@@ -1,7 +1,7 @@
 /*
- * Copyright (c) 2021, 2023, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2021, 2024, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -23,10 +23,11 @@
 
 /*
  * @test
  * @bug 8284161 8287008
  * @summary Basic test for jcmd Thread.dump_to_file
+ * @modules jdk.jcmd
  * @library /test/lib
  * @run junit/othervm ThreadDumpToFileTest
  */
 
 import java.io.IOException;
diff a/test/hotspot/jtreg/serviceability/dcmd/thread/VThreadSummaryTest.java b/test/hotspot/jtreg/serviceability/dcmd/thread/VThreadSummaryTest.java
--- /dev/null
+++ b/test/hotspot/jtreg/serviceability/dcmd/thread/VThreadSummaryTest.java
@@ -0,0 +1,168 @@
+/*
+ * Copyright (c) 2023, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @test
+ * @bug 8337199
+ * @summary Basic test for jcmd Thread.vthread_summary
+ * @requires vm.continuations
+ * @modules jdk.jcmd
+ * @library /test/lib
+ * @run junit/othervm VThreadSummaryTest
+ */
+
+import java.net.InetAddress;
+import java.net.InetSocketAddress;
+import java.net.ServerSocket;
+import java.net.Socket;
+import java.net.SocketTimeoutException;
+import java.util.List;
+import java.util.Objects;
+import java.util.concurrent.CompletableFuture;
+import java.util.concurrent.Executors;
+import java.util.concurrent.ExecutorService;
+import java.util.concurrent.ForkJoinPool;
+import java.util.concurrent.ForkJoinWorkerThread;
+import java.util.concurrent.ScheduledThreadPoolExecutor;
+import java.util.concurrent.atomic.AtomicBoolean;
+import java.util.stream.IntStream;
+import java.lang.management.ManagementFactory;
+import jdk.management.VirtualThreadSchedulerMXBean;
+
+import jdk.test.lib.dcmd.PidJcmdExecutor;
+import jdk.test.lib.process.OutputAnalyzer;
+import org.junit.jupiter.api.Test;
+import static org.junit.jupiter.api.Assertions.*;
+
+class VThreadSummaryTest {
+
+    private OutputAnalyzer jcmd() {
+        return new PidJcmdExecutor().execute("Thread.vthread_summary");
+    }
+
+    /**
+     * Test that output includes the default scheduler and timeout schedulers.
+     */
+    @Test
+    void testSchedulers() {
+        // ensure default scheduler are timeout schedulers are initialized
+        Thread.startVirtualThread(() -> { });
+
+        jcmd().shouldContain("Virtual thread scheduler:")
+                .shouldContain(Objects.toIdentityString(defaultScheduler()))
+                .shouldContain("Timeout schedulers:")
+                .shouldContain("[0] " + ScheduledThreadPoolExecutor.class.getName());
+    }
+
+    /**
+     * Test that the output includes the read and writer I/O pollers.
+     */
+    @Test
+    void testPollers() throws Exception {
+        // do blocking I/O op on a virtual thread to ensure poller mechanism is initialized
+        try (var executor = Executors.newVirtualThreadPerTaskExecutor()) {
+            executor.submit(() -> {
+                try (var listener = new ServerSocket()) {
+                    InetAddress lb = InetAddress.getLoopbackAddress();
+                    listener.bind(new InetSocketAddress(lb, 0));
+                    listener.setSoTimeout(1000);
+                    try (Socket s = listener.accept()) {
+                        fail("Connection from " + s.getRemoteSocketAddress());
+                    } catch (SocketTimeoutException e) {
+                        // expected
+                    }
+                }
+                return null;
+            }).get();
+        }
+
+        jcmd().shouldContain("Read I/O pollers:")
+                .shouldContain("Write I/O pollers:")
+                .shouldContain("[0] sun.nio.ch");
+    }
+
+    /**
+     * Test that the output includes thread groupings.
+     */
+    @Test
+    void testThreadGroupings() {
+        // ensure common pool is initialized
+        CompletableFuture.runAsync(() -> { });
+
+        try (var pool = Executors.newFixedThreadPool(1);
+             var executor = Executors.newVirtualThreadPerTaskExecutor()) {
+
+            jcmd().shouldContain("<root>")
+                    .shouldContain("ForkJoinPool.commonPool")
+                    .shouldContain(Objects.toIdentityString(pool))
+                    .shouldContain(Objects.toIdentityString(executor));
+        }
+    }
+
+    /**
+     * Test that output is truncated when there are too many thread groupings.
+     */
+    @Test
+    void testTooManyThreadGroupings() {
+        List<ExecutorService> executors = IntStream.range(0, 1000)
+                .mapToObj(_ -> Executors.newCachedThreadPool())
+                .toList();
+        try {
+            jcmd().shouldContain("<root>")
+                    .shouldContain("<truncated ...>");
+        } finally {
+            executors.forEach(ExecutorService::close);
+        }
+    }
+
+    /**
+     * Returns the virtual thread default scheduler. This implementation works by finding
+     * all FJ worker threads and mapping them to their pool. VirtualThreadSchedulerMXBean
+     * is used to temporarily changing target parallelism to an "unique" value, make it
+     * possbile to find the right pool.
+     */
+    private ForkJoinPool defaultScheduler() {
+        var done = new AtomicBoolean();
+        Thread vthread = Thread.startVirtualThread(() -> {
+            while (!done.get()) {
+                Thread.onSpinWait();
+            }
+        });
+        var bean = ManagementFactory.getPlatformMXBean(VirtualThreadSchedulerMXBean.class);
+        int parallelism = bean.getParallelism();
+        try {
+            bean.setParallelism(133);
+            return Thread.getAllStackTraces()
+                    .keySet()
+                    .stream()
+                    .filter(ForkJoinWorkerThread.class::isInstance)
+                    .map(t -> ((ForkJoinWorkerThread) t).getPool())
+                    .filter(p -> p.getParallelism() == 133)
+                    .findAny()
+                    .orElseThrow();
+        } finally {
+            bean.setParallelism(parallelism);
+            done.set(true);
+        }
+    }
+}
diff a/test/hotspot/jtreg/serviceability/jvmti/events/MonitorContendedEnter/mcontenter01/libmcontenter01.cpp b/test/hotspot/jtreg/serviceability/jvmti/events/MonitorContendedEnter/mcontenter01/libmcontenter01.cpp
--- a/test/hotspot/jtreg/serviceability/jvmti/events/MonitorContendedEnter/mcontenter01/libmcontenter01.cpp
+++ b/test/hotspot/jtreg/serviceability/jvmti/events/MonitorContendedEnter/mcontenter01/libmcontenter01.cpp
@@ -33,11 +33,10 @@
 extern "C" {
 
 /* ========================================================================== */
 
 /* scaffold objects */
-static JNIEnv *jni = nullptr;
 static jvmtiEnv *jvmti = nullptr;
 static jlong timeout = 0;
 
 /* test objects */
 static jthread expected_thread = nullptr;
@@ -69,11 +68,11 @@
   }
 }
 
 /* ========================================================================== */
 
-static int prepare() {
+static int prepare(JNIEnv* jni) {
   jvmtiError err = jvmti->SetEventNotificationMode(JVMTI_ENABLE, JVMTI_EVENT_MONITOR_CONTENDED_ENTER, nullptr);
   if (err != JVMTI_ERROR_NONE) {
     jni->FatalError("Error enabling JVMTI_EVENT_MONITOR_CONTENDED_ENTER.");
   }
   return JNI_TRUE;
@@ -90,19 +89,18 @@
 }
 
 /* agent algorithm
  */
 static void JNICALL
-agentProc(jvmtiEnv *jvmti, JNIEnv *agentJNI, void *arg) {
-  jni = agentJNI;
+agentProc(jvmtiEnv *jvmti, JNIEnv *jni, void *arg) {
 
   /* wait for initial sync */
   if (!agent_wait_for_sync(timeout)) {
     return;
   }
 
-  if (!prepare()) {
+  if (!prepare(jni)) {
     set_agent_fail_status();
     return;
   }
 
   /* clear events count */
diff a/test/hotspot/jtreg/serviceability/jvmti/events/MonitorContendedEntered/mcontentered01/libmcontentered01.cpp b/test/hotspot/jtreg/serviceability/jvmti/events/MonitorContendedEntered/mcontentered01/libmcontentered01.cpp
--- a/test/hotspot/jtreg/serviceability/jvmti/events/MonitorContendedEntered/mcontentered01/libmcontentered01.cpp
+++ b/test/hotspot/jtreg/serviceability/jvmti/events/MonitorContendedEntered/mcontentered01/libmcontentered01.cpp
@@ -30,11 +30,10 @@
 extern "C" {
 
 /* ========================================================================== */
 
 /* scaffold objects */
-static JNIEnv *jni = nullptr;
 static jvmtiEnv *jvmti = nullptr;
 static jlong timeout = 0;
 
 /* test objects */
 static jthread expected_thread = nullptr;
@@ -125,11 +124,10 @@
 
 /* agent algorithm
  */
 static void JNICALL
 agentProc(jvmtiEnv *jvmti, JNIEnv *agentJNI, void *arg) {
-  jni = agentJNI;
 
 /* wait for initial sync */
   if (!agent_wait_for_sync(timeout))
     return;
 
diff a/test/hotspot/jtreg/serviceability/jvmti/events/MonitorWaited/monitorwaited01/libmonitorwaited01.cpp b/test/hotspot/jtreg/serviceability/jvmti/events/MonitorWaited/monitorwaited01/libmonitorwaited01.cpp
--- a/test/hotspot/jtreg/serviceability/jvmti/events/MonitorWaited/monitorwaited01/libmonitorwaited01.cpp
+++ b/test/hotspot/jtreg/serviceability/jvmti/events/MonitorWaited/monitorwaited01/libmonitorwaited01.cpp
@@ -28,20 +28,23 @@
 #include "jvmti_thread.hpp"
 
 
 extern "C" {
 
+const int MAX_COUNT = 50;
+
 /* scaffold objects */
-static JNIEnv *jni = nullptr;
 static jvmtiEnv *jvmti = nullptr;
 static jlong timeout = 0;
 
 /* test objects */
 static jthread expected_thread = nullptr;
 static jobject expected_object = nullptr;
 static volatile int eventsCount = 0;
 
+static void check_stack_trace(JNIEnv* env, jthread thr);
+
 void JNICALL
 MonitorWaited(jvmtiEnv *jvmti, JNIEnv *jni, jthread thr, jobject obj, jboolean timed_out) {
 
   LOG("MonitorWaited event:\n\tthread: %p, object: %p, timed_out: %s\n",
       thr, obj, (timed_out == JNI_TRUE) ? "true" : "false");
@@ -63,14 +66,53 @@
     if (timed_out == JNI_TRUE) {
       COMPLAIN("Unexpected timed_out value: true\n");
       set_agent_fail_status();
     }
   }
+
+  if (jni->IsVirtualThread(thr)) {
+    check_stack_trace(jni, thr);
+  }
 }
 
 /* ========================================================================== */
 
+static void check_stack_trace(JNIEnv* jni, jthread thr) {
+  jvmtiError err;
+  jint count = 0;
+  jint skipped = 0;
+
+  print_stack_trace(jvmti, jni, nullptr);
+
+  jvmtiFrameInfo frameInfo[MAX_COUNT];
+
+  err = jvmti->GetStackTrace(thr, 0, MAX_COUNT, frameInfo, &count);
+  check_jvmti_status(jni, err, "event handler: error in JVMTI GetStackTrace call");
+
+  const int expected_count = 8;
+  const char* expected_methods[expected_count] = {"wait0", "wait", "run", "runWith", "run", "run", "enter0", "enter"};
+
+  if (count != expected_count) {
+    LOG("Expected 8 methods in the stack but found %d", count);
+    jni->FatalError("Unexpected method count");
+  }
+
+  for (int idx = 0; idx < count; idx++) {
+    jclass declaringClass = nullptr;
+    char *clasSignature = nullptr;
+    char *methodName = nullptr;
+
+    err = jvmti->GetMethodName(frameInfo[idx].method, &methodName, nullptr, nullptr);
+    check_jvmti_status(jni, err, "event handler: error in JVMTI GetMethodName call");
+
+    if (strcmp(methodName, expected_methods[idx]) != 0) {
+      LOG("Expected method %s but found %s", expected_methods[idx], methodName);
+      jni->FatalError("Unexpected method found");
+    }
+  }
+}
+
 static int prepare() {
   /* enable MonitorWait event */
   jvmtiError err = jvmti->SetEventNotificationMode(JVMTI_ENABLE, JVMTI_EVENT_MONITOR_WAITED, nullptr);
   if (err != JVMTI_ERROR_NONE) {
     LOG("Prepare: 11\n");
@@ -88,11 +130,10 @@
   return JNI_TRUE;
 }
 
 static void JNICALL
 agentProc(jvmtiEnv *jvmti, JNIEnv *agentJNI, void *arg) {
-  jni = agentJNI;
 
   /* wait for initial sync */
   if (!agent_wait_for_sync(timeout))
     return;
 
diff a/test/hotspot/jtreg/serviceability/jvmti/events/MonitorWaited/monitorwaited01/monitorwaited01.java b/test/hotspot/jtreg/serviceability/jvmti/events/MonitorWaited/monitorwaited01/monitorwaited01.java
--- a/test/hotspot/jtreg/serviceability/jvmti/events/MonitorWaited/monitorwaited01/monitorwaited01.java
+++ b/test/hotspot/jtreg/serviceability/jvmti/events/MonitorWaited/monitorwaited01/monitorwaited01.java
@@ -1,7 +1,7 @@
 /*
- * Copyright (c) 2003, 2023, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2003, 2024, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -38,10 +38,11 @@
  * COMMENTS
  *     The test updated to match new JVMTI spec 0.2.90:
  *     - change signature of agentProc function
  *       and save JNIEnv pointer now passed as argument.
  *
+ * @requires vm.continuations
  * @library /test/lib
  * @compile monitorwaited01.java
  * @run main/othervm/native -agentlib:monitorwaited01 monitorwaited01 platform
  * @run main/othervm/native -agentlib:monitorwaited01 monitorwaited01 virtual
  */
diff a/test/hotspot/jtreg/serviceability/jvmti/vthread/GetThreadStateMountedTest/GetThreadStateMountedTest.java b/test/hotspot/jtreg/serviceability/jvmti/vthread/GetThreadStateMountedTest/GetThreadStateMountedTest.java
--- a/test/hotspot/jtreg/serviceability/jvmti/vthread/GetThreadStateMountedTest/GetThreadStateMountedTest.java
+++ b/test/hotspot/jtreg/serviceability/jvmti/vthread/GetThreadStateMountedTest/GetThreadStateMountedTest.java
@@ -1,7 +1,7 @@
 /*
- * Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2023, 2024, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -249,17 +249,18 @@
         if (errCount > 0) {
             throw new RuntimeException("Test failed, " + errCount + " errors");
         }
     }
 
+    private static native void runFromNative(Runnable runnable);
+
     private static Thread createPinnedVThread(Runnable runnable) {
-        final Object syncObj = new Object();
-        return Thread.ofVirtual().unstarted(() -> {
-            synchronized (syncObj) {
-                runnable.run();
-            }
-        });
+        return Thread.ofVirtual().unstarted(() -> runFromNative(runnable));
+    }
+
+    private static void runUpcall(Runnable runnable) {
+        runnable.run();
     }
 
     // Native implementation of suspendWaiting.
     // Returns false if the method is not able to reach the desired state in several tries.
     private static native boolean trySuspendInWaitingState(Thread vthread);
